// Generated by LiveScript 1.5.0
var EventEmitter, HandlerManager, ref$, delegate, delegateEvent, WebSocketConnector, debug, ExoRelay;
EventEmitter = require('events').EventEmitter;
HandlerManager = require('./message-handler/message-manager');
ref$ = require('rails-delegate'), delegate = ref$.delegate, delegateEvent = ref$.delegateEvent;
WebSocketConnector = require('./websocket-connector/websocket-connector');
debug = require('debug')('exorelay');
ExoRelay = (function(superclass){
  var prototype = extend$((import$(ExoRelay, superclass).displayName = 'ExoRelay', ExoRelay), superclass).prototype, constructor = ExoRelay;
  function ExoRelay(config){
    var ref$, ref1$, ref2$, x$;
    this.config = config;
    this._sendRoutingConfig = bind$(this, '_sendRoutingConfig', prototype);
    this._onIncomingMessage = bind$(this, '_onIncomingMessage', prototype);
    this.send = bind$(this, 'send', prototype);
    ((ref$ = this.config) != null && ref$.exocomHost) || (function(){
      throw new Error('ExoCom host not provided to Exorelay');
    }());
    ((ref1$ = this.config) != null && ref1$.exocomPort) || (function(){
      throw new Error('ExoCom port not provided to Exorelay');
    }());
    ((ref2$ = this.config) != null && ref2$.role) || (function(){
      throw new Error('Role not provided to Exorelay');
    }());
    this.messageHandler = new HandlerManager();
    x$ = this.websocketConnector = new WebSocketConnector(config);
    x$.on('message', this._onIncomingMessage);
    x$.on('online', this._sendRoutingConfig);
    delegate('close', 'connect', {
      from: this,
      to: this.websocketConnector
    });
    delegate('hasHandler', 'registerHandler', 'registerHandlers', {
      from: this,
      to: this.messageHandler
    });
    delegateEvent('error', {
      from: [this.websocketConnector, this.messageHandler],
      to: this
    });
    delegateEvent('offline', {
      from: this.websocketConnector,
      to: this
    });
  }
  ExoRelay.prototype.send = function(messageName, payload, replyHandler){
    var message;
    switch (false) {
    case !(replyHandler && typeof replyHandler !== 'function'):
      return this.emit('error', Error('The reply handler given to ExoRelay#send must be a function'));
    }
    message = this.websocketConnector.send(messageName, payload);
    if (replyHandler) {
      this.messageHandler.registerReplyHandler(message.activityId, replyHandler);
    }
    return message;
  };
  ExoRelay.prototype._onIncomingMessage = function(requestData){
    if (requestData.messageName === '__status') {
      this.websocketConnector.send("__status-ok");
      return 'success';
    }
    return this.messageHandler.handleRequest(requestData, {
      reply: this.websocketConnector.replyMethodFor(requestData.activityId, requestData.sessionId),
      send: this.send
    });
  };
  ExoRelay.prototype._sendRoutingConfig = function(){
    this.send('exocom.register-service', {
      clientName: this.config.role
    });
    return this.emit('online', this.websocketConnector.exocomPort);
  };
  return ExoRelay;
}(EventEmitter));
module.exports = ExoRelay;
function bind$(obj, key, target){
  return function(){ return (target || obj)[key].apply(obj, arguments) };
}
function extend$(sub, sup){
  function fun(){} fun.prototype = (sub.superclass = sup).prototype;
  (sub.prototype = new fun).constructor = sub;
  if (typeof sup.extended == 'function') sup.extended(sub);
  return sub;
}
function import$(obj, src){
  var own = {}.hasOwnProperty;
  for (var key in src) if (own.call(src, key)) obj[key] = src[key];
  return obj;
}