// Generated by LiveScript 1.5.0
var WebSocketConnector, expect, sinon;
WebSocketConnector = require('./websocket-connector');
expect = require('chai').expect;
sinon = require('sinon');
describe('WebSocketConnector', function(){
  beforeEach(function(){
    var x$, this$ = this;
    x$ = this.websocketConnector = new WebSocketConnector({
      exocomHost: 'localhost',
      exocomPort: 4100,
      role: 'test'
    });
    x$.connect();
    x$.on('error', function(error){
      this$.error = error;
    });
    return x$;
  });
  afterEach(function(done){
    return this.websocketConnector.close(done);
  });
  return describe('reply-method-for', function(){
    beforeEach(function(){
      this.websocketConnector.send = sinon.stub();
      return this.replyMethod = this.websocketConnector.replyMethodFor('123', '1');
    });
    it('returns a function that calls @send prebound to the response id', function(){
      expect(this.replyMethod).to.be.a('function');
      this.replyMethod('reply-message', 'payload');
      return expect(this.websocketConnector.send.firstCall.args).to.eql([
        'reply-message', 'payload', {
          activityId: '123',
          sessionId: '1'
        }
      ]);
    });
    return context('missing activity-id', function(){
      beforeEach(function(){
        return this.websocketConnector.replyMethodFor(null);
      });
      return it('emits an error', function(done){
        expect(this.error.message).to.eql('WebSocketConnector.replyMethodFor needs an activity-id');
        return done();
      });
    });
  });
});